'use strict';

var bytes = require('../bytes.js');
var buffer = require('buffer');
var baseX = require('base-x');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var baseX__default = /*#__PURE__*/_interopDefaultLegacy(baseX);

const wrap = obj => ({
  encode: b => obj.encode(buffer.Buffer.from(b)),
  decode: s => bytes.coerce(obj.decode(s))
});
const btc = '123456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz';
const flickr = '123456789abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNPQRSTUVWXYZ';
var base58 = [{
  name: 'base58btc',
  prefix: 'z',
  ...wrap(baseX__default['default'](btc))
}, {
  name: 'base58flickr',
  prefix: 'Z',
  ...wrap(baseX__default['default'](flickr))
}];

module.exports = base58;
