'use strict';

var index = require('./index.js');
var raw = require('./codecs/raw.js');
var json = require('./codecs/json.js');
var base32 = require('./bases/base32.js');
var sha2 = require('./hashes/sha2.js');

var create = base64 => {
  const multiformats = index.create();
  multiformats.multihash.add(sha2);
  multiformats.multicodec.add([raw, json]);
  multiformats.multibase.add([base32, base64]);
  return multiformats;
};

module.exports = create;
